"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = require("fs");
var path_1 = require("path");
var child_process_1 = require("child_process");
var proxyBuilder = "\nlet ready = false;\n\nconst g = self || window || global\n\nif (!g.__gobridge__) {\n  g.__gobridge__ = {};\n}\n\nconst bridge = g.__gobridge__;\n\nasync function init() {\n  const go = new Go();\n  let result = await WebAssembly.instantiateStreaming(fetch(\"main.wasm\"), go.importObject);\n  go.run(result.instance);\n  ready = true;\n}\n\nfunction sleep() {\n  return new Promise(requestAnimationFrame);\n}\n\ninit();\n\nlet proxy = new Proxy(\n  {},\n  {\n    get: (_, key) => {\n      return (...args) => {\n        return new Promise(async (resolve, reject) => {\n          let run = () => {\n            let cb = (err, ...msg) => (err ? reject(err) : resolve(...msg));\n            bridge[key].apply(undefined, [...args, cb]);\n          };\n\n          while (!ready) {\n            await sleep();\n          }\n          run();\n        });\n      };\n    }\n  }\n);\n  \nexport default proxy;\n  ";
var getGoBin = function (root) { return root + "/bin/go"; };
function loader(contents) {
    var _this = this;
    var cb = this.async();
    var opts = {
        env: {
            GOPATH: process.env.GOPATH,
            GOROOT: process.env.GOROOT,
            GOOS: "js",
            GOARCH: "wasm"
        }
    };
    var goBin = getGoBin(opts.env.GOROOT);
    var outFile = this.resourcePath + ".wasm";
    var args = ["build", "-o", outFile, this.resourcePath];
    child_process_1.execFile(goBin, args, opts, function (_, err) {
        if (err) {
            cb(new Error(err));
            return;
        }
        var out = fs_1.readFileSync(outFile);
        fs_1.unlinkSync(outFile);
        _this.emitFile("main.wasm", out, null);
        cb(null, [
            "require('!",
            path_1.join(__dirname, "..", "lib", "wasm_exec.js"),
            "');",
            proxyBuilder
        ].join(""));
    });
}
exports.default = loader;
//# sourceMappingURL=index.js.map